package types

import "gopkg.in/yaml.v3"

type PathOrList []string

//	func (p PathOrList) MarshalYAML() (interface{}, error) {
//		return yaml.Marshal(p)
//	}
func (p *PathOrList) UnmarshalYAML(value *yaml.Node) error {

	var multi []string
	err := value.Decode(&multi)
	if err != nil {
		var single string
		err := value.Decode(&single)
		if err != nil {
			return err
		}
		*p = []string{single}
	} else {
		*p = multi
	}
	return nil
}

//func (p *PathOrList) UnmarshalYAML(b interface{}) error {
//	var s string
//	if err := yaml.Unmarshal(b, &s); err != nil {
//		return err
//	}
//
//	return nil
//}

type Sync struct {
	Source struct {
		Selector string `yaml:"selector"`
		Path     string `yaml:"path"`
	} `yaml:"source"`
	Destination struct {
		Selector string     `yaml:"selector"`
		Path     PathOrList `yaml:"path"`
		Exclude  []string   `yaml:"exclude"`
	} `yaml:"destination"`
}

type SyncSpecification struct {
	Sync []Sync `yaml:"sync"`
}
